<?php

/**
 * Planativtare
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     robertomartins - 13/01/2011 15:00:59 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Planativtare extends DaoPlanativtare {


    /**
     * Altera status da atividade.
     *
     * @param string $upidstativtar Id da situacao a ser alterada.
     * @param string $cdfilial      Codigo da filial.
     * @param string $nrtarefa      Numero da tarefa.
     * @param string $nrplativtare  Numero do plano da atividade.
     *
     * @return boolean
     */
    static public function alteraStatusAtvidade(
        $upidstativtar,
        $cdfilial,
        $nrtarefa,
        $nrplativtare
        ) {

        try{
            $db = TkDbAdapter::getWorkConnection();
            $query = $db->createQuery()
                ->update('PLANATIVTARE')
                ->set('IDSITATIVTAR', '\''.$upidstativtar.'\'')
                ->addWhere('CDFILIAL  = '.'\''.$cdfilial.'\'')
                ->addWhere('NRTAREFA  = '.'\''.$nrtarefa.'\'')
                ->addWhere('NRPLATIVTARE  = '.'\''.$nrplativtare.'\'');

            $row = $db->execute($query);
        }
        catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
        }

        if ($row instanceof Doctrine_Adapter_Statement) {
            return true;
        } else {
            return false;
        }
    }


    /**
     * Retorna o plano da atividade.
     *
     * @param string $cdfilial     Codigo da filial.
     * @param string $nrtarefa     Numero da tarefa.
     * @param string $nrplativtare Numero do plano da atividade.
     *
     * @return boolean
     */
    static public function retornaListaPlanoAtvidades($cdfilial, $nrtarefa, $nrplativtare) {

        try {
            $select = 'CDFILIAL=? AND NRTAREFA = ? AND NRPLATIVTARE = ?';
            $obj = self::getObjectByWhere(
                $select,
                array(
                 $cdfilial,
                 $nrtarefa,
                 $nrplativtare,
                )
            );
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);

            return false;
        }
        $obj = $obj->getCdoperresp();
        return $obj;
    }


    /**
     * Altera data final da atividade.
     *
     * @param string $dtfirativtar Data final da atividade.
     * @param string $cdfilial     Codigo da filial.
     * @param string $nrtarefa     Numero da tarefa.
     * @param string $nrplativtare Numero do plano da atividade.
     *
     * @return boolean
     */
    static public function alteraDtfirativtar($dtfirativtar, $cdfilial, $nrtarefa, $nrplativtare) {
        $db = TkDbAdapter::getWorkConnection();
        $query = $db->createQuery()
            ->update('PLANATIVTARE')
            ->set('DTFIRATIVTAR', '\''.$dtfirativtar.'\'')
            ->addWhere('CDFILIAL  = '.'\''.$cdfilial.'\'')
            ->addWhere('NRTAREFA  = '.'\''.$nrtarefa.'\'')
            ->addWhere('NRPLATIVTARE  = '.'\''.$nrplativtare.'\'');

        $row = $db->execute($query);

        if ($rows instanceof Doctrine_Adapter_Statement) {
            return true;
        } else {
            return false;
        }

    }


    /**
     * Retorna a atividade que esta com a situacao em andamento.
     *
     * @param string $cdfilial   Codigo da filial.
     * @param string $cdoperresp Operador responsavel.
     *
     * @return Ambigous <TkModel, unknown, mixed, NULL>
     */
    static public function retornaAtividadeAndamento($cdfilial,$cdoperresp){

        try {
            $select = 'CDFILIAL = ? AND CDOPERRESP = ? AND IDSITATIVTAR = ?';
            $obj = self::getObjectByWhere(
                $select,
                array(
                 $cdfilial,
                 $cdoperresp,
                 'A',
                )
            );
            if ($obj instanceof PlanativtareEntity){
            return $obj;
            }
            else{
                return false;
            }
        } catch (Exception $e){
            showClassError($e, __FUNCTION__, __LINE__);
        }

    }


    /**
     * Retorna a atividade que esta com a situacao em interrompida.
     *
     * @param string $cdfilial   Codigo da filial.
     * @param string $cdoperresp Operador responsavel.
     *
     * @return Ambigous <TkModel, unknown, mixed, NULL>
     */
    static public function retornaAtividadesInterrompidas($cdfilial,$cdoperresp){

        try {
            $select = 'CDFILIAL=? AND CDOPERRESP = ? AND IDSITATIVTAR = ?';
            $obj = self::getObjectsByWhere(
                $select,
                array(
                 $cdfilial,
                 $cdoperresp,
                 'I',
                )
            );

            return $obj;
        } catch (Exception $e){
            showClassError($e, __FUNCTION__, __LINE__);
        }

    }


    /**
     * Select que retona as atividade do colocaborador logado.
     *
     * @param string $cdfilial  Codigo da filial.
     * @param string $coperador Codigo do operador.
     *
     * @return string
     */
    static public function retornaConsultaAtividades(){

        $filial = mtk_get_filial();
        $operador = ftk_get_operador();

//        $sql= "SELECT PL.DTINPATIVTAR, PL.DTFIPATIVTAR, PL.NRPRIOATIVTR, PL.NRTAREFA,
//               PL.NRPLATIVTARE, PL.DTFIRATIVTAR,IT.CDTIPOITTRAB,
//               PR.NMPROCESSO, PL.CDPROCESSO, PL.CDQUALIFPROC, IT.CDREDUITTRAB,
//               PL.CDFILIAL    , PL.IDSITATIVTAR, PL.DTCONATIVTAR, PL.NRCPLXITATIV,
//               PL.NRREPETATIV , SL.CDPROJETO   , PJ.NMPROJETO   , PL.CDITEMTRAB  ,
//               IT.NMITEMTRAB  , S.CDPRODGRUP  ,
//               TF.IDORIGTARE  , IT.CDARVITTRAB ,
//               TF.DSREFETAREFA, TF.NRPRIOTAREFA, TF.NRSOLISERV  , TF.DTHRREUNIAO ,
//               PL.CDOPERINCL  , O2.NMOPERADOR    AS NMOPERINCL  , PL.CDOPERRESP  ,
//               PL.DTINCATIVTAR, OP.NMOPERADOR AS NMOPERRESP,
//               OS.NMOPERADOR AS NMOPERSOLI, A.NMASSUNTO, S.DSREFESOLI,
//               S.DTPREVRCONSO AS DTPREVENCSOL, S.DTCOMPROMISS, C.NMFANTCLIE,
//               PRO.DSDIRBASEVER, PRO.DSDIRVSS, PR.VRFATOCPLX,
//               SL.CDPROJETO||' - '||PJ.NMPROJETO  AS DSPROJETO,
//               NVL(DECODE((TRIM(TO_NUMBER(S.NRSOLISERV))||' - '||S.DSREFESOLI)
//                ,' - ',('TAREFA '||TRIM(TO_NUMBER(TF.NRTAREFA)) ||' - ' || TF.DSREFETAREFA)),
//                (TRIM(TO_NUMBER(S.NRSOLISERV))||' - '||S.DSREFESOLI)) AS DSSOLISERV,
//               LPAD(TO_CHAR(TRUNC(NVL(PL.QTTEMPLAITAR,0))),2,'0')||
//               ':'||LPAD(TO_CHAR(TRUNC(NVL((PL.QTTEMPLAITAR - TRUNC(PL.QTTEMPLAITAR)),0)*60)),2,'0')
//               AS DSTEMPLAITAR,PR.IDGERATVCONS,
//               OP.CDEMPRESA, OP.CDFUNC, PL.IDSTATUSATESTE, TP.IDAUTOTESTE,
//               FT.DSSTFASETRAM,SL.NRBASELINEPR
//          FROM PLANATIVTARE PL, PROCESSO PR, TAREFA TF, PROJETO PJ,
//               ITEMTRAB IT, OPERADOR OP, OPERADOR O2, OPERADOR OS, FASETRAM FT,
//               SOLISERV S, CLIENTE C, ASSUNTO A, PRODUTO PRO, SOLIBASELINE SL, TIPOITTRAB TP
//         WHERE TP.CDTIPOITTRAB(+) = IT.CDTIPOITTRAB
//           AND PL.CDFILIAL = '$filial'
//           AND PL.CDOPERRESP = '$operador'
//           AND PL.CDPROCESSO = PR.CDPROCESSO(+)
//           AND PL.CDFILIAL = TF.CDFILIAL(+)
//           AND PL.NRTAREFA = TF.NRTAREFA(+)
//           AND PL.CDOPERRESP = OP.CDOPERADOR(+)
//           AND PL.CDOPERINCL = O2.CDOPERADOR(+)
//           AND PL.CDITEMTRAB = IT.CDITEMTRAB(+)
//           AND SL.CDPROJETO = PJ.CDPROJETO(+)
//           AND TF.CDFILIAL = S.CDFILIAL(+)
//           AND TF.NRSOLISERV = S.NRSOLISERV(+)
//           AND S.CDCLIENTE = C.CDCLIENTE(+)
//           AND S.CDOPERRESP = OS.CDOPERADOR(+)
//           AND S.CDASSUNTO = A.CDASSUNTO(+)
//           AND S.CDPRODGRUP = PRO.CDPRODUTO(+)
//           AND S.CDFILIAL = SL.CDFILIAL(+)
//           AND S.NRSOLISERV = SL.NRSOLISERV(+)
//           AND S.CDFASETRAM = FT.CDFASETRAM(+)
//           AND PL.IDSITATIVTAR NOT IN ('C','X')
//           AND TF.IDORIGTARE <> '5'
//           AND ((SL.CDPROJETO = (SELECT MAX(CDPROJETO)
//                                   FROM SOLIBASELINE SB
//                                  WHERE SB.CDFILIAL = S.CDFILIAL
//                                    AND SB.NRSOLISERV = S.NRSOLISERV)) OR (SL.CDPROJETO IS NULL))
//           AND (PL.CDPROCESSO ='0000011077' OR PL.CDPROCESSO = '0000011078' OR PJ.CDPROJETO IS NULL)
//
//         ORDER BY 1, 2, 3, 4, 5, 6";


        $sql=  "SELECT
  ATI.DTINICIOPLANEJADO,
  ATI.DTFIMPLANEJADO,
  ATI.NRTAREFA,
  ATI.NRATIVIDADE,
  ATI.DTFINALIZACAO,
  ATP.NmAtividadeProc,
  ATI.NRATIVIDADEPROC,
  ITE.NmItemTrabalho,
  ATI.IDSITUACAOATIV,
  ATI.DTCONCLUSAO,
  ATI.NRITEMTRABALHO ,
  ITE.NMITEMTRABALHO ,
  ATI.CDOPERINCLUSAO,
  OPI.NMOPERADOR AS NMOPERINCL ,
  ATI.NRPARCOPERRESP ,
  ATI.DTINCLUSAO,
  OPR.NMSECUNDARIPARC AS NMOPERRESP,
  OPS.NMSECUNDARIPARC AS NMOPERSOLI,
  TSO.NMTIPOSOLICITACAO,
  SOL.DsReferenciaSoli,
  PNS.NMSECUNDARIPARC,
  SIT.DsCompletaSitu
FROM
  GEP_ATIVIDADE ATI,
  GEP_ATIVIDADEPROC ATP,
  GEP_ITEMTRABALHO ITE,
  PARCNEGOCIO OPR,
  OPERADOR OPI,
  PARCNEGOCIO OPS,
  GEP_SITUACAO SIT,
  GEP_SOLICITACAO SOL,
  PARCNEGOCIO PNS,
  GEP_TIPOSOLICITACAO TSO
WHERE
  ATI.NRPARCOPERRESP      = '267031'
AND ATI.NRATIVIDADEPROC   = ATP.NRATIVIDADEPROC(+)
AND ATI.NRSOLICITACAO     = SOL.NRSOLICITACAO(+)
AND ATI.NRPARCOPERRESP    = OPR.NRPARCNEGOCIO (+)
AND ATI.CDOPERINCLUSAO    = OPI.CDOPERADOR(+)
AND ATI.NRITEMTRABALHO    = ITE.NRITEMTRABALHO(+)
AND SOL.NrParcNegoSoli    = PNS.NRPARCNEGOCIO(+)
AND SOL.NRPARCOPERRESP    = OPS.NRPARCNEGOCIO(+)
AND SOL.NRTIPOSOLICITACAO = TSO.NRTIPOSOLICITACAO(+)
AND SOL.NRSITUACAO        = SIT.NRSITUACAO(+)
ORDER BY
  1,
  2,
  3,
  4,
  5,
  6
        ";

        tk_message($sql);
        return $sql;

    }


     /**
     * Altera status da atividade.
     *
     * @param string $idsitcheckout Id da situacao a ser alterada.
     * @param string $cditemtrab    Codigo do item de trabalho.
     *
     * @return boolean
     */
    static public function alteraIdstcheckout(
        $idsitcheckout,
        $cditemtrab
        ) {
        $nrorg = ftk_get_nrorg();
        try{
            $db = TkDbAdapter::getWorkConnection();
            $query = $db->createQuery()
                ->update('ITEMTRAB')
                ->set('IDSTCHECKOUT', '\''.$idsitcheckout.'\'')
                ->addWhere('CDITEMTRAB  = '.'\''.$cditemtrab.'\'')
                ->addWhere('NRORG  = '.'\''.$nrorg.'\'');

            $row = $db->execute($query);
        }
        catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
        }

        if ($row instanceof Doctrine_Adapter_Statement) {
            return true;
        } else {
            return false;
        }
    }

    static function retornaAtividadExport($cditemtrab){
        try{
            $db = TkDbAdapter::getWorkConnection();
            $query = $db->createQuery()
                     ->select('nmitemtrab')
                     ->from('itemtrab')
                     ->addWhere('CDITEMTRAB =',$cditemtrab);

            $row = $db->execute($query);
            return $row;
        }
        catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
        }

     }


}