CREATE OR REPLACE TRIGGER STATUS_LOTECTB_APRCUSTOP BEFORE DELETE ON APRCUSTOP
FOR EACH ROW
DECLARE
  V_CDLOTE VARCHAR2(20);
  V_NRLANCLOTE VARCHAR2(06);
  V_DTINICCTBL DATE;
  V_DTFINACCTBL DATE;
  V_DTORDPRODUCAO DATE;
  V_CDEMPRESA VARCHAR2(2);
  V_IDTPGERACAOCONT VARCHAR2(02);
BEGIN
   BEGIN
      SELECT IDTPGERACAOCONT
        INTO V_IDTPGERACAOCONT
        FROM PARAMCTBL;
   EXCEPTION
    WHEN NO_DATA_FOUND THEN
      V_IDTPGERACAOCONT := NULL;
   END;

   IF V_IDTPGERACAOCONT <> 'O' THEN

      BEGIN
         SELECT CDEMPRESA
           INTO V_CDEMPRESA
           FROM FILIAL
          WHERE CDFILIAL = :OLD.CDFILIAL;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          V_CDEMPRESA := NULL;
      END;

      BEGIN
         SELECT DTINIINTCONTDFE,DTFININTCONTDFE
           INTO V_DTINICCTBL, V_DTFINACCTBL
           FROM CONTOPECTBL
          WHERE CDEMPRESA = V_CDEMPRESA;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
         V_DTINICCTBL := NULL;
         V_DTFINACCTBL := NULL;
      END;

      BEGIN
         SELECT MAX(DTHRFIMREAOP)
           INTO V_DTORDPRODUCAO
           FROM ORDPRODUCAO
          WHERE CDFILIAL = :OLD.CDFILIAL
            AND NRORDPROD = :OLD.NRORDPROD;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
         V_DTORDPRODUCAO := NULL;
      END;

      IF DELETING THEN
         IF V_DTORDPRODUCAO IS NULL THEN
            V_DTORDPRODUCAO := SYSDATE;
         END IF;
         IF V_DTORDPRODUCAO >= V_DTINICCTBL AND V_DTORDPRODUCAO <= V_DTFINACCTBL THEN
            BEGIN
              SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                INTO V_CDLOTE, V_NRLANCLOTE
                FROM RELACAPRLANCLOT
               WHERE  CDFILIAL = :OLD.CDFILIAL
                 AND  NRORDPROD = :OLD.NRORDPROD;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_CDLOTE := NULL;
                 V_NRLANCLOTE := NULL;
            END;

            DELETE FROM RELACAPRLANCLOT
             WHERE CDEMPRESA = V_CDEMPRESA
               AND NRLANCLOTE = V_NRLANCLOTE
               AND CDFILIAL = :OLD.CDFILIAL
               AND NRORDPROD = :OLD.NRORDPROD;

            DELETE FROM LANCLOTE
             WHERE CDEMPRESA = V_CDEMPRESA
               AND CDLOTE = V_CDLOTE
               AND NRLANCLOTE = V_NRLANCLOTE;

            REVERTE_LOTE(V_CDEMPRESA,V_CDLOTE);
         ELSE
            RAISE_APPLICATION_ERROR(-20501,'Excluso no permitida, data fora do perodo contbil.',True);
         END IF;
      END IF;
   END IF;
END;
/

