/*
@C:\WEB_645\SQL\END_CONV\ORACLE\CLIENTES\CLO\0010_CLOSTPO_USR_ATUALIZA_POSI.SQL

 DESCRIO:
 PROCEDURE PARA GERAO DO SALDO DE ESTOQUE PARA UTILIZAO CONFOMRE API

 RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/


CREATE OR REPLACE PROCEDURE USR_ATUALIZAPOSIESTOQ
IS
   V_QTRESERVA     FLOAT;
   V_CDTIPCUSTEST  VARCHAR2(2);
BEGIN
   V_QTRESERVA := 0;
   DELETE FROM USR_POSIESTOQ;

   FOR C_FILIAL IN (SELECT CDFILIAL
                      FROM FILIAL)
   LOOP
      INSERT INTO USR_POSIESTOQ (CDPRODUTO, CDPRODINTE, QTESTOQDIA, VRESTOQDIA, VRESTOQBRUT,
                                 VRMEDIO, VRMEDIOBRUT, NRORG, NMPRODUTO, SGUNIDADE,
                                 CDPRODESTO, CDFILIAL,  CDALMOXARIFE, CDLOCALESTOQ,
                                 DSALMOXARIFE, DSLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                                 CDARVPROD, VRCUSTOPROD, VRTOTALPROD)
      SELECT B.CDPRODUTO,
             A.CDPRODINTE,
             QTESTOQDIA,
             VRESTOQDIA,
             VRESTOQBRUT,
             DECODE(QTESTOQDIA, 0, VRESTOQDIA, (VRESTOQDIA /QTESTOQDIA)) AS VRMEDIO,
             DECODE(QTESTOQDIA, 0, VRESTOQBRUT, (VRESTOQBRUT/QTESTOQDIA)) AS VRMEDIOBRUT,
             B.NRORG,
             A.NMPRODUTO,
             A.SGUNIDADE,
             A.CDPRODESTO,
             B.CDFILIAL,
             B.CDALMOXARIFE,
             B.CDLOCALESTOQ,
             AL.DSALMOXARIFE,
             LE.DSLOCALESTOQ,
             B.NRLOTEESTQ,
             B.NRSUBLOTE,
             A.CDARVPROD,
             VRCUSTOPROD,
             VRCUSTOPROD * QTESTOQDIA AS VRTOTALPROD
        FROM ALMOXARIFADO AL,
             LOCALESTOQUE LE,
             (SELECT D.CDPRODUTO,
                     D.NMPRODUTO,
                     D.SGUNIDADE,
                     D.CDARVPROD,
                     D.CDPRODESTO,
                     D.CDPRODINTE,
                     D.NRORG
                FROM PRODUTO D
               WHERE D.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)) A,
             (SELECT CDFILIAL,
                     CDALMOXARIFE,
                     CDLOCALESTOQ,
                     NRLOTEESTQ,
                     QTESTOQDIA,
                     CDPRODUTO,
                     NRSUBLOTE,
                     DTPOSIESTQ,
                     VRESTOQBRUT,
                     VRESTOQDIA,
                     NRORG,
                     NVL(CUSTO_PRODUTO_LCEST(POE.CDFILIAL, CDPRODUTO, 3, TO_DATE(SYSDATE)-1, SYSDATE, POE.CDALMOXARIFE, POE.CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE),0) AS VRCUSTOPROD
                FROM POSESTDIA POE
               WHERE POE.CDFILIAL = C_FILIAL.CDFILIAL)B
       WHERE (B.CDPRODUTO     = A.CDPRODUTO)
         AND (AL.CDFILIAL     = B.CDFILIAL)
         AND (AL.CDALMOXARIFE = B.CDALMOXARIFE)
         AND (LE.CDFILIAL     = B.CDFILIAL)
         AND (LE.CDALMOXARIFE = B.CDALMOXARIFE)
         AND (LE.CDLOCALESTOQ = B.CDLOCALESTOQ)
         AND (B.DTPOSIESTQ    =  (SELECT MAX(P.DTPOSIESTQ)
                                    FROM POSESTDIA P
                                   WHERE P.CDFILIAL     = B.CDFILIAL
                                     AND P.CDPRODUTO    = B.CDPRODUTO
                                     AND P.CDALMOXARIFE = B.CDALMOXARIFE
                                     AND P.CDLOCALESTOQ = B.CDLOCALESTOQ
                                     AND P.NRLOTEESTQ   = B.NRLOTEESTQ
                                     AND P.NRSUBLOTE    = B.NRSUBLOTE
                                     AND P.DTPOSIESTQ  <= SYSDATE));
      COMMIT;
   END LOOP;

   FOR C_POSICAO IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                       FROM USR_POSIESTOQ)
   LOOP
      BEGIN
         SELECT SUM(A.QTRESERVA)
           INTO V_QTRESERVA
           FROM (SELECT QTRESPRODARR as QTRESERVA
                   FROM RESERPRODPED
                  WHERE CDFILIAL     = C_POSICAO.CDFILIAL
                    AND CDALMOXARIFE = C_POSICAO.CDALMOXARIFE
                    AND CDLOCALESTOQ = C_POSICAO.CDLOCALESTOQ
                    AND NRLOTEESTQ   = C_POSICAO.NRLOTEESTQ
                    AND NRSUBLOTE    = C_POSICAO.NRSUBLOTE
                    AND CDPRODUTO    = C_POSICAO.CDPRODUTO
                  UNION ALL
                 SELECT QTRESERVESTOL AS QTRESERVA
                   FROM RESERVAPEDEXOL RS, RELACPRODOL RL
                  WHERE RS.CDPRODUTO   = RL.CDPRARVORIG
                    AND RS.CDMARCA     = RL.CDMARCA
                    AND RS.CDFILRESOL  = C_POSICAO.CDFILIAL
                    AND RL.CDPRODARVOL = C_POSICAO.CDPRODUTO) A;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_QTRESERVA := 0;
      END;

      IF V_QTRESERVA > 0 THEN
         UPDATE USR_POSIESTOQ
            SET QTESTOQDIA  = (QTESTOQDIA - V_QTRESERVA),
                VRESTOQDIA  = ROUND(VRESTOQDIA - (V_QTRESERVA * (VRESTOQDIA / QTESTOQDIA)),5),
                VRESTOQBRUT = ROUND(VRESTOQBRUT - (V_QTRESERVA * (VRESTOQBRUT / QTESTOQDIA)),5),
                VRMEDIO     = ROUND((VRESTOQDIA - (V_QTRESERVA * (VRESTOQDIA / QTESTOQDIA))) / DECODE((QTESTOQDIA - V_QTRESERVA), 0, 1, (QTESTOQDIA - V_QTRESERVA)),5),
                VRMEDIOBRUT = ROUND((VRESTOQBRUT - (V_QTRESERVA * (VRESTOQBRUT / QTESTOQDIA))) / DECODE((QTESTOQDIA - V_QTRESERVA), 0, 1, (QTESTOQDIA - V_QTRESERVA)),5),
                VRTOTALPROD = VRCUSTOPROD * (QTESTOQDIA - V_QTRESERVA)
          WHERE CDFILIAL     = C_POSICAO.CDFILIAL
            AND CDALMOXARIFE = C_POSICAO.CDALMOXARIFE
            AND CDLOCALESTOQ = C_POSICAO.CDLOCALESTOQ
            AND NRLOTEESTQ   = C_POSICAO.NRLOTEESTQ
            AND NRSUBLOTE    = C_POSICAO.NRSUBLOTE
            AND CDPRODUTO    = C_POSICAO.CDPRODUTO;
      END IF;         
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATUALIZAPOSIESTOQ','6.45.009'); END;
/
