CREATE OR REPLACE PROCEDURE ETL_LAVCMV(P_DTINICIAL  DATE,
                                       P_DTFINAL    DATE,  
                                       P_CDFILIAL VARCHAR2)  
IS  
  V_ANO                VARCHAR2(04);  
  V_MES                VARCHAR2(02);  
  V_TRI                VARCHAR2(10);  
  V_BIM                VARCHAR2(10);  
  V_SEM                VARCHAR2(10);  
  V_NRMOVIESTQ         VARCHAR2(20);  
  V_DTINI              DATE;  
  V_DTFIM              DATE;
  V_CONT               NUMBER;
  V_VRESTINICMV        NUMBER;
  V_VRESTFINCMV        NUMBER;
  V_VRENTRADCMV        NUMBER;
  V_VRDEVOLUCMV        NUMBER;
  V_VRCUSTOCMV         NUMBER;
  V_VRCUSTESTRCMV      NUMBER;
  V_NRMOVIESTQ2        VARCHAR2(20);
  V_VRIMPLANTACAO      NUMBER;
  V_CONTADOR           VARCHAR2(10);
  V_VRCUSTENTR         NUMBER;
  V_DTINICTBL          DATE;
  V_DTFINCTBL          DATE;
  V_QTEFETPRIN         FLOAT;
  V_QTEFETTERC         FLOAT;
  V_TOTEFETIVO         FLOAT;

BEGIN

   SELECT dtinicctbl, dtfinacctbl
     INTO V_DTINICTBL, V_DTFINCTBL
     FROM CONTOPECTBL
    WHERE CDEMPRESA = '01';

   IF P_DTINICIAL >= V_DTINICTBL AND P_DTFINAL <= V_DTFINCTBL THEN
      V_MES := TO_CHAR(P_DTINICIAL,'MM');
      V_ANO := TO_CHAR(P_DTFINAL,'YYYY');
      V_VRESTINICMV  := 0;
      V_VRESTFINCMV  := 0;
      V_VRENTRADCMV  := 0;
      V_VRDEVOLUCMV  := 0;
      V_VRCUSTOCMV   := 0;
      V_VRIMPLANTACAO := 0;
      V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINICIAL,'MMYYYY'),'DDMMYYYY');
      WHILE (V_DTINI <= P_DTFINAL) LOOP
         V_DTFIM := LAST_DAY(V_DTINI);
         V_ANO :=  TO_CHAR(V_DTFIM,'YYYY');
         V_MES :=  TO_CHAR(V_DTFIM,'MM');
         V_BIM :=  TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' Bim';  
         V_TRI :=  TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' Tri';  
         V_SEM :=  TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' Sem';  
         FOR C_ETLFILIAL IN  
            (SELECT F.CDFILIAL, F.CDAREAGERE, F.CDSEGMER, F.CDEMPRESA,  
                    F.CDSUPERVISOR, F.CDGOPERAC, CDTIPCUSTEST, DECODE(PG.IDUTILDTPROC, 'S', NVL(PF.DTPROCESSA, SYSDATE), SYSDATE) DTPROCESSA  
               FROM  FILIAL F, PARAMFILIAL PF, PARAMGERAL PG  
              WHERE PF.CDFILIAL = F.CDFILIAL  
                AND NVL(IDCNTRRESC,'N') = 'N'  
                AND F.CDFILIAL = P_CDFILIAL) LOOP  
  
            DELETE FROM LAV_ETLCMV  
             WHERE CDFILIAL = C_ETLFILIAL.CDFILIAL  
               AND ((CDANOBI = V_ANO) and (CDMESBI = substr(P_DTINICIAL,4,2)));  
  
            DELETE FROM LAV_ETLMERCESTR  
             WHERE CDFILIAL = C_ETLFILIAL.CDFILIAL  
               AND ((CDANOBI = V_ANO) and (CDMESBI = substr(P_DTINICIAL,4,2)));  
  
            SELECT SUM(DECODE(CF.IDUTCONTCLPR, 'S', QTEFETIVOS, 0)) QTEFETIVOPRIN,  
                   SUM(DECODE(CF.IDUTCONTCLPR, 'N', QTEFETIVOS, 0)) QTEFETIVOTERC  
              INTO V_QTEFETPRIN, V_QTEFETTERC  
              FROM SUM_EFETIVOS SE, CLIENFILIAL CF  
             WHERE SE.CDFILIAL = C_ETLFILIAL.CDFILIAL  
               AND SE.DTFATURAM BETWEEN P_DTINICIAL AND LAST_DAY(P_DTINICIAL)  
               AND SE.CDFILIAL = CF.CDFILIAL  
               AND SE.CDCLIENTE = CF.CDCLIENTE;           
  
            V_TOTEFETIVO := V_QTEFETPRIN + V_QTEFETTERC;  
              
            IF ADD_MONTHS(LAST_DAY(C_ETLFILIAL.DTPROCESSA) + 1 , -1) >= V_DTINI THEN  
               SELECT SUM(NVL(CUSTO_PRODUTO(B.CDFILIAL, B.CDPRODUTO, NVL(TO_NUMBER(C_ETLFILIAL.CDTIPCUSTEST),3),  
                      TO_DATE(V_DTINI - 1), SYSDATE),0) * QTESTDIACON) AS VRCUSTOTOTAL  
                 INTO V_VRESTINICMV  
                 FROM POSESTCONS B,  
                      (SELECT D.CDPRODUTO, D.NMPRODUTO, D.SGUNIDADE,  
                              D.CDARVPROD, D.CDPRODESTO, N.NMPRODUTO AS NMPRODNIVEL  
                         FROM PRODUTO D, PRODUTO N  
                        WHERE D.CDARVPROD BETWEEN '1' AND '8ZZZZZZZ' AND  
                              N.CDARVPROD = SUBSTR(D.CDARVPROD,0,'1')) A  
  
                WHERE B.CDFILIAL = C_ETLFILIAL.CDFILIAL  
                  AND B.QTESTDIACON <> 0  
                  AND B.CDPRODUTO = A.CDPRODUTO  
                  AND A.CDPRODUTO = A.CDPRODESTO  
                  AND B.DTPOSESTCON = (SELECT MAX(P.DTPOSESTCON)  
                                         FROM POSESTCONS P  
                                        WHERE P.CDFILIAL = B.CDFILIAL  
                                          AND P.CDPRODUTO = B.CDPRODUTO  
                                          AND P.DTPOSESTCON <= V_DTINI);  
  
               SELECT SUM(NVL(CUSTO_PRODUTO(B.CDFILIAL, B.CDPRODUTO, NVL(TO_NUMBER(C_ETLFILIAL.CDTIPCUSTEST),3), V_DTFIM, SYSDATE),0) * QTESTDIACON) AS VRCUSTOTOTAL  
                 INTO V_VRESTFINCMV  
                 FROM POSESTCONS B,  
                      (SELECT D.CDPRODUTO, D.NMPRODUTO, D.SGUNIDADE,  
                              D.CDARVPROD, D.CDPRODESTO, N.NMPRODUTO AS NMPRODNIVEL  
                       FROM PRODUTO D, PRODUTO N  
                       WHERE D.CDARVPROD BETWEEN '1' AND '8ZZZZZZZ' AND  
                             N.CDARVPROD = SUBSTR(D.CDARVPROD,0,'1')) A  
                WHERE B.CDFILIAL = C_ETLFILIAL.CDFILIAL  
                  AND B.QTESTDIACON <>  0  
                  AND B.CDPRODUTO = A.CDPRODUTO  
                  AND A.CDPRODUTO = A.CDPRODESTO  
                  AND B.DTPOSESTCON = (SELECT MAX(P.DTPOSESTCON)  
                                         FROM POSESTCONS P  
                                        WHERE P.CDFILIAL = B.CDFILIAL  
                                          AND P.CDPRODUTO = B.CDPRODUTO  
                                          AND P.DTPOSESTCON <= V_DTFIM+1);  
               SELECT LPAD(ABS(ROUND(DBMS_RANDOM.VALUE(9999,9999999999))),10,'0')  
                 INTO V_NRMOVIESTQ  
                 FROM DUAL;  
  
               MOVIMENTACAO_ESTOQUE(C_ETLFILIAL.CDFILIAL,NULL,NULL,NULL, 1, V_DTINI, V_DTFIM,  '1', 'zzzzzzzzzzz', 3, 1,V_NRMOVIESTQ, 'S');  
  
  select sum(VRCUSTENTRME)  INTO V_VRENTRADCMV from(
               SELECT SUM(VRCUSTENTRME)  as VRCUSTENTRME
                  
                 FROM RELAT_MOVIEST R, LAV_ALMOXARIFECMV A, LAV_TIPOOPERCMV T  
                WHERE NRRELATMOVI = V_NRMOVIESTQ  
                  AND CDFILIMOVIEST = C_ETLFILIAL.CDFILIAL  
                  AND CDALMOXARIRM  = A.CDALMOXARIFE  
                  AND CDFILIMOVIEST = A.CDFILIAL  
                  AND IDTIPOMOVIEST IN ('2', 'E')  
                  AND CDTIPOOPERME = T.CDTIPOOPER  
                  AND IDENTRSAIDME = T.IDENTRSAIDOP  
                  AND IDENTRSAIDME = 'E'
                  union
                  SELECT 
                 SUM(DECODE(CDTIPOOPERME, '03', VRCUSTMEDI, 0)) AS VRCUSTENTRME
                FROM RELAT_MOVIEST 
                WHERE IDTIPOMOVIEST = '2'         AND  
                      NRRELATMOVI   = V_NRMOVIESTQ  AND 
                      QTLANCAMENTO  = 0            AND 
                      CDFILIMOVIEST = C_ETLFILIAL.CDFILIAL);  
  
               BEGIN  
                  SELECT SUM(QTLANCAMENTO * VRCUSTMEDI) AS VRIMPLANTACAO  
                    INTO V_VRIMPLANTACAO  
                    FROM RELAT_MOVIEST R, LAV_ALMOXARIFECMV A  
                   WHERE NRRELATMOVI   = V_NRMOVIESTQ  
                     AND CDFILIMOVIEST = C_ETLFILIAL.CDFILIAL  
                     AND CDALMOXARIRM  = A.CDALMOXARIFE  
                     AND CDFILIMOVIEST = A.CDFILIAL  
                     AND IDTIPOMOVIEST = '0';  
               EXCEPTION  
                  WHEN NO_DATA_FOUND THEN  
                    V_VRIMPLANTACAO := 0;  
               END;  
  
               V_VRENTRADCMV := NVL(V_VRENTRADCMV,0) + NVL(V_VRIMPLANTACAO,0);  
  
               SELECT SUM(QTLANCAMENTO * VRCUSTMEDI)  
                 INTO V_VRDEVOLUCMV  
                 FROM RELAT_MOVIEST R, LAV_ALMOXARIFECMV A, LAV_TIPOOPERCMV T  
                WHERE NRRELATMOVI = V_NRMOVIESTQ  
                  AND CDFILIMOVIEST = C_ETLFILIAL.CDFILIAL  
                  AND CDALMOXARIRM  = A.CDALMOXARIFE  
                  AND CDFILIMOVIEST = A.CDFILIAL  
                  AND IDTIPOMOVIEST IN ('4', 'S', '5')  
                  AND CDTIPOOPERME = T.CDTIPOOPER  
                  AND IDENTRSAIDME = T.IDENTRSAIDOP  
                  AND IDENTRSAIDME = 'S';  
  
               V_VRCUSTOCMV := (NVL(ROUND(V_VRESTINICMV, 2),0) + NVL(V_VRENTRADCMV,0)) - (NVL(V_VRDEVOLUCMV,0) + NVL(ROUND(V_VRESTFINCMV, 2),0));  
               V_VRCUSTOCMV := ROUND(V_VRCUSTOCMV, 2); 
               INSERT INTO LAV_ETLCMV  
                  (CDFILIAL, CDANOBI, CDMESBI, BIETLCMV, TRETLCMV, SEETLCMV,  
                   VRESTINICMV, VRESTFINCMV, VRENTRADCMV, VRDEVOLUCMV, VRCUSTOCMV)  
                VALUES  
                   (C_ETLFILIAL.CDFILIAL, V_ANO, V_MES, V_BIM, V_TRI, V_SEM,  
                    V_VRESTINICMV, V_VRESTFINCMV, V_VRENTRADCMV, V_VRDEVOLUCMV, V_VRCUSTOCMV);  
  
               FOR C_ITEMESTRAT IN  
                  (SELECT L.CDFILIAL ,  L.NRSEQCUSTO, L.DSCUSTOETR, L.IDTPCUSTO, L.CDGRUPOESTR,  
                          L.IDAPURCLIPRITER  
                     FROM LAV_CUSTOMERESTR L  
                    WHERE CDFILIAL = C_ETLFILIAL.CDFILIAL  
                   ORDER BY L.CDGRUPOESTR, L.NRSEQCUSTO, L.IDTPCUSTO) LOOP  
  
                  IF C_ITEMESTRAT.IDTPCUSTO = 'AJ' THEN  
                     FOR C_ITCUSTOMERESTR IN (  
                        SELECT *  
                          FROM LAV_ITCUSTOMERESTR  
                         WHERE CDFILIAL = C_ITEMESTRAT.CDFILIAL  
                           AND CDGRUPOESTR = C_ITEMESTRAT.CDGRUPOESTR  
                           AND NRSEQCUSTO = C_ITEMESTRAT.NRSEQCUSTO) LOOP  
  
                        SELECT LPAD(ABS(ROUND(DBMS_RANDOM.VALUE(9999,9999999999))),10,'0')  
                          INTO V_NRMOVIESTQ2  
                          FROM DUAL;  
  
                        MOVIMENTACAO_ESTOQUE(C_ETLFILIAL.CDFILIAL, C_ITCUSTOMERESTR.CDALMOXARIFE,NULL,NULL, 1, V_DTINI, V_DTFIM,  '1', 'zzzzzzzzzzz', 3, 1,V_NRMOVIESTQ2);  
  
                        SELECT sum(DECODE(A.QTLANCTOEST, 0, (ROUND(R.QTTOTALANT,3)* ROUND(R.VRCUSTMEDI,5)) * (-1),(ROUND((A.QTLANCTOEST -R.QTTOTALANT),3) * ROUND(R.VRCUSTMEDI,5))))AS VRTOTAL  
                          INTO V_VRCUSTESTRCMV  
                          FROM ITLANCTOEST A, RELAT_MOVIEST R, PRODUTO P  
                         WHERE A.CDFILIMOVI = C_ETLFILIAL.CDFILIAL  
                           AND A.CDALMOXARIFE = C_ITCUSTOMERESTR.CDALMOXARIFE  
                           AND A.CDPRODMOVI = P.CDPRODUTO  
                           AND A.IDTIPOMOVI = '1'  
                           AND R.NRRELATMOVI = V_NRMOVIESTQ2  
                           AND R.CDFILIMOVIEST = C_ETLFILIAL.CDFILIAL  
                           AND R.NRLANCMOVIEST = A.NRLANCESTQ  
                           AND R.NRSEQUMOVIEST = A.NRSEQUITEM  
                           AND R.CDALMOXARIRM = A.CDALMOXARIFE  
                           AND R.CDLOCALESTRM = A.CDLOCALESTOQ  
                           AND R.CDPRODMOVIEST = P.CDARVPROD  
                           AND R.IDTIPOMOVIEST = '1';  
                     END LOOP;  
                  END IF;  
  
                  IF C_ITEMESTRAT.IDTPCUSTO = 'LS' THEN  
                     SELECT SUM(QTLANCTOEST * NVL(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, DTLANCMOVI, SYSDATE,IT.CDALMOXARIFE,IT.CDLOCALESTOQ),0))  
                       INTO V_VRCUSTESTRCMV  
                       FROM NOTAFISCAL N, LANCTOESTOQ L, ITLANCTOEST IT, LAV_ITCUSTOMERESTR C  
                      WHERE IT.CDFILIMOVI = C_ETLFILIAL.CDFILIAL  
                        AND L.CDFILIAL = N.CDFILIAL  
                        AND L.NRLANCTONF = N.NRLANCTONF  
                        AND L.CDFILIAL = IT.CDFILIAL  
                        AND L.NRLANCESTQ = IT.NRLANCESTQ  
                        AND IT.DTLANCMOVI BETWEEN V_DTINI  AND V_DTFIM  
                        AND NVL(IT.IDEVOLESTOQ, 'S') = 'S'  
                        AND N.IDENTRSAIDOP = 'S'  
                        AND N.CDTIPOOPER = C.CDTIPOOPER  
                        AND C.CDFILIAL = C_ITEMESTRAT.CDFILIAL  
                        AND C.CDGRUPOESTR = C_ITEMESTRAT.CDGRUPOESTR  
                        AND C.NRSEQCUSTO = C_ITEMESTRAT.NRSEQCUSTO  
                        AND IDSISTEMA <> 'VND' ;  
                  END IF;  
                  
                  /* Retirada por Servio */
                  IF C_ITEMESTRAT.IDTPCUSTO = 'RP' THEN  
                     SELECT SUM(QTRETIRADA * NVL(CUSTO_PRODUTO_LCEST(CDFILIAL, CDPRODUTO, 3, DTCARDAPIO, SYSDATE,CDALMOXARIFE,CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE),0))  
                       INTO V_VRCUSTESTRCMV  
                       FROM (SELECT CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO, IL.CDALMOXARIFE,  
                                    IL.CDLOCALESTOQ, IL.NRLOTEESTQ, IL.NRSUBLOTE, IR.CDPRODUTO,  
                                    SUM(IR.QTRETIRADA * PRA.VRFATOCONV) AS QTRETIRADA  
                               FROM CARDADIA CA, ITLANCTOEST IL, LAV_ITCUSTOMERESTR I, LAV_ALMOXARIFECMV A,  
                                    ITEMRETI IR, PRODUTO PRA  
                              WHERE CA.CDFILIAL = C_ETLFILIAL.CDFILIAL  
                                AND CA.CDFILIAL = I.CDFILIAL  
                                AND CA.CDSERVFILI = I.CDSERVFILI  
                                AND (IR.CDTIPORETI = I.CDTIPORETI OR I.CDTIPORETI = 'T')  
                                AND I.CDGRUPOESTR = C_ITEMESTRAT.CDGRUPOESTR  
                                AND I.NRSEQCUSTO = C_ITEMESTRAT.NRSEQCUSTO  
                                AND IL.CDFILIAL = IR.CDFIITLANEST  
                                AND IL.NRLANCESTQ = IR.NRLANCESTQ  
                                AND IL.NRSEQUITEM = IR.NRSEQUITEM  
                                AND NVL(IL.IDEVOLESTOQ,'S') = 'S'  
                                AND DTLANCMOVI BETWEEN V_DTINI AND V_DTFIM  
                                AND A.CDALMOXARIFE = IL.CDALMOXARIFE 
                                AND A.CDFILIAL = IL.CDFILIMOVI 
                                AND CA.CDFILIAL = IR.CDFILIAL  
                                AND CA.NRCARDAPIO = IR.NRCARDAPIO  
                                AND  PRA.CDPRODUTO = IR.CDPRODUTO  
                             GROUP BY CA.CDFILIAL,CA.CDSERVFILI,CA.DTCARDAPIO, IL.CDALMOXARIFE, IL.CDLOCALESTOQ,  
                                      IL.NRLOTEESTQ, IL.NRSUBLOTE, IR.CDPRODUTO);  
                      IF C_ITEMESTRAT.IDAPURCLIPRITER = 'P' THEN  
                         V_VRCUSTESTRCMV := ROUND((V_QTEFETPRIN * V_VRCUSTESTRCMV) / V_TOTEFETIVO, 2);  
                      ELSIF C_ITEMESTRAT.IDAPURCLIPRITER = 'T' THEN  
                         V_VRCUSTESTRCMV := ROUND((V_QTEFETTERC * V_VRCUSTESTRCMV) / V_TOTEFETIVO, 2);  
                      END IF;  
                  END IF;  
  
                  IF C_ITEMESTRAT.IDTPCUSTO = 'RE' THEN  
                     SELECT SUM(QTLANCTOEST * NVL(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, DTLANCMOVI, SYSDATE,IT.CDALMOXARIFE,IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE),0))  
                       INTO V_VRCUSTESTRCMV  
                       FROM LAV_ALMOXARIFECMV A, LAV_ITCUSTOMERESTR I, ITLANCTOEST IT, RETIRADAESTO R  
                      WHERE IT.CDFILIMOVI = C_ETLFILIAL.CDFILIAL  
                        AND NVL(IT.IDEVOLESTOQ, 'S') = 'S'  
                        AND DTLANCMOVI BETWEEN  V_DTINI AND V_DTFIM  
                        AND IDTIPOMOVI = '3'  
                        AND A.CDALMOXARIFE = IT.CDALMOXARIFE  
                        AND A.CDFILIAL = IT.CDFILIMOVI  
                        AND IT.CDFILIMOVI = I.CDFILIAL(+)  
                        AND (R.CDSETOR = I.CDSETOR OR I.CDSETOR = 'T')  
                        AND (IT.CDTIPORETI = I.CDTIPORETI OR I.CDTIPORETI = 'T')  
                        AND I.CDGRUPOESTR = C_ITEMESTRAT.CDGRUPOESTR  
                        AND I.NRSEQCUSTO = C_ITEMESTRAT.NRSEQCUSTO  
                        AND R.CDFILIALLAN = IT.CDFILIAL  
                        AND R.NRLANCESTQ = IT.NRLANCESTQ;  
                  END IF;  
  
                  IF C_ITEMESTRAT.IDTPCUSTO = 'LF' THEN  
  
                     SELECT SUM(QTLANCTOEST * NVL(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, DTLANCMOVI, SYSDATE,IT.CDALMOXARIFE,IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE),0))  
                       INTO V_VRCUSTESTRCMV  
                       FROM NOTAFISCAL N, LANCTOESTOQ L, ITLANCTOEST IT, LAV_ITCUSTOMERESTR C  
                      WHERE N.CDFILIAL = L.CDFILIAL  
                        AND N.NRLANCTONF = L.NRLANCTONF  
                        AND L.CDFILIAL = IT.CDFILIAL  
                        AND L.NRLANCESTQ = IT.NRLANCESTQ  
                        AND NVL(IT.IDEVOLESTOQ, 'S') = 'S'  
                        AND IT.CDFILIMOVI = C_ETLFILIAL.CDFILIAL  
                        AND IT.DTLANCMOVI BETWEEN V_DTINI  AND V_DTFIM  
                        AND N.IDENTRSAIDOP  = 'S'  
                        AND IT.CDALMOXARIFE = C.CDALMOXARIFE  
                        AND IT.CDFILIMOVI = C.CDFILIAL  
                        AND C.CDGRUPOESTR = C_ITEMESTRAT.CDGRUPOESTR  
                        AND C.NRSEQCUSTO = C_ITEMESTRAT.NRSEQCUSTO  
                        AND IDSISTEMA IN ('VND', 'PDV');  
  
                     IF C_ITEMESTRAT.NRSEQCUSTO = '0000000011' THEN  
                        SELECT NVL(SUM(QTLANCTOEST * NVL(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, I.CDPRODMOVI, NVL(TO_NUMBER(C_ETLFILIAL.CDTIPCUSTEST),3), DTLANCMOVI, SYSDATE,IT.CDALMOXARIFE,IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE),0)),0)  
                          INTO V_VRCUSTENTR  
                          FROM ITEMPRODUTO I, NOTAFISCAL N, LANCTOESTOQ L, ITLANCTOEST IT  
                         WHERE IT.CDFILIMOVI = C_ETLFILIAL.CDFILIAL  
                           AND I.CDFILIAL = N.CDFILIAL  
                           AND I.NRLANCTONF = N.NRLANCTONF  
                           AND L.CDFILIAL = N.CDFILIAL  
                           AND L.NRLANCTONF = N.NRLANCTONF  
                           AND L.CDFILIAL = IT.CDFILIAL  
                           AND L.NRLANCESTQ = IT.NRLANCESTQ  
                           AND I.CDPRODMOVI = IT.CDPRODMOVI  
                           AND IT.DTLANCMOVI BETWEEN V_DTINI AND V_DTFIM  
                           AND NVL(IT.IDEVOLESTOQ, 'S') = 'S'  
                           AND N.IDENTRSAIDOP = 'S'  
                           AND N.CDTIPOOPER = '31';  
  
                        V_VRCUSTESTRCMV := V_VRCUSTESTRCMV + V_VRCUSTENTR;  
                     END IF;  
                  END IF;  
                  INSERT INTO LAV_ETLMERCESTR  
                     (CDFILIAL, CDANOBI, CDMESBI, BIETLCMV, TRETLCMV, SEETLCMV, NRSEQCUSTO, VRCUSTESTRCMV, CDGRUPOESTR)  
                  VALUES  
                     (C_ETLFILIAL.CDFILIAL, V_ANO, V_MES, V_BIM, V_TRI, V_SEM, C_ITEMESTRAT.NRSEQCUSTO, NVL(V_VRCUSTESTRCMV,0), C_ITEMESTRAT.CDGRUPOESTR);  
               END LOOP;  
            END IF;  
  
            V_CONT := V_CONT + 1;  
            IF V_CONT >= 100 THEN  
               V_CONT := 0;  
               COMMIT;  
            END IF;  
         END LOOP;  
         V_DTINI := ADD_MONTHS(V_DTINI,1);  
      END LOOP;  
   ELSE  
      raise_application_error(-20501, 'DATA DE GERAO DO CMV FORA DO PERODO DE INTEGRAO FINANCEIRO', True);  
   END IF;  
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_LAVCMV','5.65.000'); END;
/
