const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const controleFiscalPage = require('../../../page-objects/parametrizacao/documentos fiscais/controleFiscal.po.js');
const j = require('../../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const controleFiscalGridId = '185571561241662044983419';
const impostoObrigatorioGridId = '185571561238541811193420';

describe('Tela Controle Fiscal', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		controleFiscalPage.abrir();
		j.getValor('tipoOperacao1');
	});

	afterEach(() => {
		geral.sair();
	});

	it('Acessar a tela Controle Fiscal', () => {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${controleFiscalGridId}`)));

		expect(z.component.header.getTitle())
			.toBe('Controle Fiscal');
	});

	it('Editar um tipo de operação de controle fiscal', () => {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${controleFiscalGridId}`)));
		geral.clickGrid('NMTIPOOPER', j.getValor('tipoOperacao1'), controleFiscalGridId);
		geral.clickEditar();
		controleFiscalPage.editaOperacao('Não', 'Não');
		geral.clickSalvar();
		geral.waitFieldVisibility('IDOBINFCSTICMENT');

		expect(geral.getTextoPorId('IDOBINFCSTICMENT'))
			.toBe('Não');
		expect(geral.getTextoPorId('IDOBINFCSTICMENT'))
			.toBe('Não');
	});

	it('Adicionar um registro na aba Impostos Obrigatórios', () => {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${controleFiscalGridId}`)));
		geral.clickGrid('NMTIPOOPER', j.getValor('tipoOperacao1'), controleFiscalGridId);
		geral.trocarAba('Impostos Obrigatórios');
		geral.clickAdicionar();
		geral.searchAndClickGridField('CDIMPOSTO', j.getValor('impostoObrigatorio'), 'NMIMPOSTO');
		geral.clickSalvar();

		expect(geral.gridHasText(impostoObrigatorioGridId, j.getValor('codigoImpostoObrigatorio')))
			.toBe(j.getValor('codigoImpostoObrigatorio'));
		expect(geral.gridHasText(impostoObrigatorioGridId, j.getValor('impostoObrigatorio'), 1))
			.toBe(j.getValor('impostoObrigatorio'));
	});

	it('Excluir o registro da aba Impostos Obrigatórios', () => {
		geral.clickGrid('NMTIPOOPER', j.getValor('tipoOperacao1'), controleFiscalGridId);
		geral.trocarAba('Impostos Obrigatórios');
		geral.clickGrid('NMIMPOSTO', j.getValor('impostoObrigatorio'), impostoObrigatorioGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(impostoObrigatorioGridId, j.getValor('codigoImpostoObrigatorio')))
			.toBeUndefined();
		expect(geral.gridHasText(impostoObrigatorioGridId, j.getValor('impostoObrigatorio'), 1))
			.toBeUndefined();
	});

	it('Editar a situação tributária do imposto fiscal dos pré-requisitos na aba Situação ' +
		'Tributária para o imposto indicado nos pré-requisitos', () => {
			const situacaoTributariaGridId = '18557156122186958743469';
			geral.trocarAba('Situação Tributária');
			geral.selectNative('IDENTRSAIDOP', 'Entrada');
			geral.selectNative('CDIMPOSTO', j.getValor('impostoFiscal'));
			geral.filterIt(j.getValor('codigoSituacaoTributaria'));
			geral.clickGrid('CDSITUTRIB', j.getValor('codigoSituacaoTributaria'), situacaoTributariaGridId);
			geral.clickEditar();
			controleFiscalPage.editaStiuacaoTributaria('Sim', 'Não');
			geral.clickSalvar();
			geral.waitFieldVisibility('IDUTILIZACST');

			expect(geral.getTextoPorId('IDUTILIZACST'))
				.toBe('Sim');
			expect(geral.getTextoPorId('IDOBRVRIMPOS'))
				.toBe('Não');
		});
});
